searchNodes=[{"type":"module","title":"TelemetryEmitter.Emitter","doc":"Emit metrics declared with Telemetry.Metrics . Metric names are represented at strings separated by . or lists of atoms. Each name must have at least two segments, the last segment being the measurement. All functions have the metric as the first argument. There is also an optional metadata argument that accepts a map of metric metadata, including tag values. Examples Increment a counter: Emitter . increment ( &quot;request.count&quot; ) Or: Emitter . increment ( [ :request , :count ] ) Measure the time of a function call: Emitter . measure ( &quot;request.stop.duration&quot; , %{ operation : &quot;op1&quot; } , fn -&gt; { Service . operation ( ... ) , %{ } } end )","ref":"TelemetryEmitter.Emitter.html"},{"type":"function","title":"TelemetryEmitter.Emitter.emit/3","doc":"Emit a metric with explicit measurements. This works with any of the declarations from Telemetry.Metrics . In this case, measurements are provided by the measurements argument and the entirety of metric is used as the name of the emitted Telemetry event. This is largely an alias for :telemetry.execute/3 . Examples counter ( &quot;service.request.count&quot; ) , summary ( &quot;service.request.duration&quot; , unit : { :native , :millisecond } ) , Emitter . emit ( &quot;service.request&quot; , %{ count : 1 , duration : 5 } ) The metric service.request will be emitted with both the count and duration measurements.","ref":"TelemetryEmitter.Emitter.html#emit/3"},{"type":"function","title":"TelemetryEmitter.Emitter.gauge/3","doc":"Emit the current value of the gauge as a number. Define the metric using Telemetry.Metrics.last_value/2 . Telemetry.Metrics . last_value ( &quot;memory_usage.ratio&quot; ) Then emit the metric using the same name: Emitter . gauge ( &quot;memory_usage.ratio&quot; , 0.88 ) The metric will be emitted as memory_usage with the measurement, %{ratio: 0.88} .","ref":"TelemetryEmitter.Emitter.html#gauge/3"},{"type":"function","title":"TelemetryEmitter.Emitter.increment/3","doc":"Increment the value of the counter metric. The last segment of the metric is the measurement. Define the metric using Telemetry.Metrics.counter/2 . Telemetry.Metrics . counter ( &quot;request.count&quot; ) Then emit the metric using the same name: Emitter . increment ( &quot;request.count&quot; ) The metric will be emitted as request with the measurement %{count: 1} . Note If the metric is delcared as a counter, the measurement value will always be 1. Define the metric as a sum to increment the value by more than 1: Telemetry.Metrics . sum ( &quot;request.count&quot; ) Then emit the metric using the same name: Emitter . increment ( &quot;request.count&quot; , 99 ) The metric will be emitted as request with the measurement %{count: 99} .","ref":"TelemetryEmitter.Emitter.html#increment/3"},{"type":"function","title":"TelemetryEmitter.Emitter.measure/3","doc":"Measure the duration of the given function. The metric name may be the same as the .stop metric: prefix.stop.duration where prefix is any aribitrary metric name and the suffix .stop.duration is required. The metric is reported as prefix.stop with a measurement of :duration . Alternatively, the .stop.duration portion may be omitted for convenience. In this case the metric argument must match the prefix of the declared metric. The given function must return a tuple, {return_value, stop_metadata} . The start_metadata parameter is emitted for the .start event. The stop_metadata is emitted for the .stop event. The return_value will be the value returned by this function. Define the metric using Telemetry.Metrics.summary/2 . Examples Declaring the metric using Telemetry.Metrics.summary/2 : Telemetry.Metrics . summary ( &quot;my.external.service.call.start.system_time&quot; , tags : [ :operation ] , unit : { :native , :millisecond } ) Telemetry.Metrics . summary ( &quot;my.external.service.call.stop.duration&quot; , tags : [ :operation ] , unit : { :native , :millisecond } ) Telemetry.Metrics . summary ( &quot;my.external.service.call.exception.duration&quot; , tags : [ :operation ] , unit : { :native , :millisecond } ) Emitting the metric using TelemetryEmitter.Emitter.measure/3 : Emitter . measure ( &quot;my.external.service.call&quot; , %{ operation : :record } , fn -&gt; { MyExternalService . call ( ... ) , %{ } } end ) Note the use of the base metric name in the first argument to measure/3 . You may also use the full .stop name, my.external.service.call.stop.duration . Do not use the metric .start.system_time suffix in the first argument. If the metric with both the .start.system_time and .stop.duration suffixes are declared, both will be emitted: The my.external.service.call.start metric will be emitted with a system_time measurement of the start time of the call. The my.external.service.call.stop metric will be emitted with a duration measurement of the duration of calling the function parameter. The my.external.service.call.exception metric will be emitted if an exception is raised. It will have a duration measurement of the duration of calling the function parameter. This function delegates to :telemetry.span/3 , so see the documentation for that function for additional information.","ref":"TelemetryEmitter.Emitter.html#measure/3"},{"type":"module","title":"TelemetryEmitter.CaptureReporter","doc":"A reporter captures measurements in process state. This is useful for testing but nothing else.","ref":"TelemetryEmitter.CaptureReporter.html"},{"type":"function","title":"TelemetryEmitter.CaptureReporter.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"TelemetryEmitter.CaptureReporter.html#child_spec/1"},{"type":"function","title":"TelemetryEmitter.CaptureReporter.recorded/2","doc":"Return metrics recorded under the given metric . Emitter . increment ( &quot;service.request.count&quot; ) assert %{ measurement : %{ count : 1 } , tags : %{ } , unit : :unit } = CaptureReporter . recorded ( pid , &quot;service.request&quot; )","ref":"TelemetryEmitter.CaptureReporter.html#recorded/2"},{"type":"function","title":"TelemetryEmitter.CaptureReporter.start_link/1","doc":"Initialize the reporter with a list of metrics. Create metrics using Telemetry.Metrics . { :ok , pid } = TelemetryEmitter.CaptureReporter . start_link ( metrics : metrics )","ref":"TelemetryEmitter.CaptureReporter.html#start_link/1"}]